﻿using UnityEngine;
using HarmonyLib;
using Newtonsoft.Json;

public class StrongDiver : Mod
{
    public float originalOxygenStat = RAPI.GetLocalPlayer() != null &&
        RAPI.GetLocalPlayer().Stats.stat_oxygen.GetOxygenLostPerSecond() > 0 &&
        RAPI.GetLocalPlayer().Stats.stat_oxygen.GetOxygenLostPerSecond() != null ?
        RAPI.GetLocalPlayer().Stats.stat_oxygen.GetOxygenLostPerSecond() : 1f;

    public float originalSwimSpeed = RAPI.GetLocalPlayer() != null &&
        RAPI.GetLocalPlayer().PersonController.swimSpeed > 0 &&
        RAPI.GetLocalPlayer().PersonController.swimSpeed != null ?
        RAPI.GetLocalPlayer().PersonController.swimSpeed : 1f;

    public void Start()
    {
        if(RAPI.GetLocalPlayer() != null)
        {
            if (originalSwimSpeed > 0 || originalSwimSpeed == null)
            {
                RAPI.GetLocalPlayer().PersonController.swimSpeed = originalSwimSpeed;
            }
            else
            {
                RAPI.GetLocalPlayer().PersonController.swimSpeed = 1f;
            }

            RAPI.GetLocalPlayer().Stats.stat_oxygen.SetOxygenLostPerSecond(0.50f);
        }

        Debug.Log("Mod StrongDiver has been loaded!");
    }

    public override void WorldEvent_WorldLoaded()
    {
        originalSwimSpeed = RAPI.GetLocalPlayer().PersonController.swimSpeed;

        if (originalSwimSpeed > 0 || originalSwimSpeed == null)
        {
            RAPI.GetLocalPlayer().PersonController.swimSpeed = originalSwimSpeed;
        }
        else
        {
            RAPI.GetLocalPlayer().PersonController.swimSpeed = 1f;
        }

            RAPI.GetLocalPlayer().Stats.stat_oxygen.SetOxygenLostPerSecond(0.50f);
        Debug.Log("The world is loaded!");
    }

    public void Update () {

        if(RAPI.GetLocalPlayer() != null)
        {
            if (Input.GetKeyDown(KeyCode.LeftShift))
            {
                RAPI.GetLocalPlayer().PersonController.swimSpeed = originalSwimSpeed + 3;
            }
            if (Input.GetKeyUp(KeyCode.LeftShift))
            {
                if (originalSwimSpeed > 0 || originalSwimSpeed == null)
                {
                    RAPI.GetLocalPlayer().PersonController.swimSpeed = originalSwimSpeed;
                }
                else
                {
                    RAPI.GetLocalPlayer().PersonController.swimSpeed = 1f;
                }
            }
        }
    }

    public void OnModUnload()
    {

        if(RAPI.GetLocalPlayer() != null)
        {
            if (originalSwimSpeed > 0 || originalSwimSpeed == null)
            {
                RAPI.GetLocalPlayer().PersonController.swimSpeed = originalSwimSpeed;
            }
            else
            {
                RAPI.GetLocalPlayer().PersonController.swimSpeed = 1f;
            }

            RAPI.GetLocalPlayer().Stats.stat_oxygen.SetOxygenLostPerSecond(originalOxygenStat);
        }

        Debug.Log("Mod StrongDiver has been unloaded!");
    }
}